/*
 *  xtiger port on PSP 
 *
 *  Copyright (C) 2006 Ludovic Jacomme (ludovic.jacomme@gmail.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

# ifndef _KBD_H_
# define _KBD_H_

# define KBD_UP           0
# define KBD_RIGHT        1
# define KBD_DOWN         2
# define KBD_LEFT         3
# define KBD_TRIANGLE     4
# define KBD_CIRCLE       5
# define KBD_CROSS        6
# define KBD_SQUARE       7
# define KBD_SELECT       8
# define KBD_START        9
# define KBD_HOME        10
# define KBD_HOLD        11
# define KBD_LTRIGGER    12
# define KBD_RTRIGGER    13

# define KBD_MAX_BUTTONS 14

  enum ti92_button_id {
    TI92_BUTTON_Q           ,
    TI92_BUTTON_W           ,
    TI92_BUTTON_E           ,
    TI92_BUTTON_R           ,
    TI92_BUTTON_T           ,
    TI92_BUTTON_Y           ,
    TI92_BUTTON_U           ,
    TI92_BUTTON_I           ,
    TI92_BUTTON_O           ,
    TI92_BUTTON_P           ,
    TI92_BUTTON_7           ,
    TI92_BUTTON_8           ,
    TI92_BUTTON_9           ,
    TI92_BUTTON_MULTIPLY    ,

    TI92_BUTTON_A           ,
    TI92_BUTTON_S           ,
    TI92_BUTTON_D           ,
    TI92_BUTTON_F           ,
    TI92_BUTTON_G           ,
    TI92_BUTTON_H           ,
    TI92_BUTTON_J           ,
    TI92_BUTTON_K           ,
    TI92_BUTTON_L           ,
    TI92_BUTTON_4           ,
    TI92_BUTTON_5           ,
    TI92_BUTTON_6           ,
    TI92_BUTTON_MINUS       ,

    TI92_BUTTON_SHIFT       ,
    TI92_BUTTON_Z           ,
    TI92_BUTTON_X           ,
    TI92_BUTTON_C           ,
    TI92_BUTTON_V           ,
    TI92_BUTTON_B           ,
    TI92_BUTTON_N           ,
    TI92_BUTTON_M           ,
    TI92_BUTTON_THETA       ,
    TI92_BUTTON_ENTER_1     ,
    TI92_BUTTON_1           ,
    TI92_BUTTON_2           ,
    TI92_BUTTON_3           ,
    TI92_BUTTON_PLUS        ,

    TI92_BUTTON_ON          ,
    TI92_BUTTON_DIAMOND     ,
    TI92_BUTTON_2ND_1       ,
    TI92_BUTTON_STORE       ,
    TI92_BUTTON_SPACE       ,
    TI92_BUTTON_EQUALS      ,
    TI92_BUTTON_BACKSPACE   ,
    TI92_BUTTON_ENTER_2     ,
    TI92_BUTTON_0           ,
    TI92_BUTTON_PERIOD      ,
    TI92_BUTTON_NEGATE      ,
    TI92_BUTTON_ENTER3      ,

    TI92_BUTTON_2ND_2       ,

    TI92_BUTTON_MODE        ,

    TI92_BUTTON_CLEAR       ,

    TI92_BUTTON_LN          ,
    TI92_BUTTON_ESCAPE      ,
    TI92_BUTTON_APPS        ,
    TI92_BUTTON_ENTER4      ,

    TI92_BUTTON_SIN         ,
    TI92_BUTTON_COS         ,
    TI92_BUTTON_TAN         ,
    TI92_BUTTON_POWER       ,

    TI92_BUTTON_PALEFT      ,
    TI92_BUTTON_PARIGHT     ,
    TI92_BUTTON_COMMA       ,
    TI92_BUTTON_DIVIDE      ,

    TI92_BUTTON_LEFT        ,
    TI92_BUTTON_DOWN        ,
    TI92_BUTTON_UP          ,
    TI92_BUTTON_RIGHT       ,

    TI92_BUTTON_F1          ,
    TI92_BUTTON_F2          ,
    TI92_BUTTON_F3          ,
    TI92_BUTTON_F4          ,
    TI92_BUTTON_F5          ,
    TI92_BUTTON_F6          ,
    TI92_BUTTON_F7          ,
    TI92_BUTTON_F8          ,

    TI92_BUTTON_HAND        ,

    TI92_LAST_BUTTON
  };

  typedef struct ti92_button_t {
    char                *name;
    int                  code;
    int                  x, y;
    unsigned int         w, h;
    int                  xor_id;
  } ti92_button_t;

  extern int  psp_update_keys(void);
  extern void kbd_wait_start(void);
  extern void psp_init_keyboard(void);
  extern void psp_kbd_wait_no_button(void);

# endif
